/**
 * Articulations and Bridges
 *
 * Complexity (Time): O(n + m)
 * Complexity (Space): O(n + m)
 */

vector<int> graph[MAX];

int cont[MAX], parent[MAX];
int low[MAX], L[MAX];

// Find all articulations and bridges in the graph
void dfs(int x) {
  int child = 0;
  cont[x] = 1;

  for (auto i : graph[x]) {
    if (!cont[i]) {
      child++;
      parent[i] = x;

      low[i] = L[i] = L[x] + 1;
      dfs(i);
      low[x] = min(low[x], low[i]);

      if ((parent[x] == -1 && child > 1) || (parent[x] != -1 && low[i] >= L[x]))
        // CAUTION: may be executed more than once for the same vertex
        // ==== x is an articulation point ====

      if (low[i] > L[x])
        // ==== (x,i) is a bridge ====

    } else if (parent[x] != i) {
      low[x] = min(low[x], L[i]);
    }
  }
}


void tarjan(int v) {
  memset(parent, -1, sizeof parent);
  dfs(v);
}
